import unittest
from selenium import webdriver
from selenium.webdriver.common.keys import Keys
import harkdesigner


class PythonNode (harkdesigner.TestHarkDesigner):
    def test_LearningHARK001(self):
        self.zoom(3)
        self.setDisplay("Line", "Lines")

        self.addSheet("MAIN_LOOP")

        # build main loop
        self.activateSheet("MAIN_LOOP")
        for node in ["AudioStreamFromMic","MultiFFT","MatrixToMap",
                     "PowerCalcForMap","MelFilterBank","MSLSExtraction",
                     "FeatureRemover","ConstantLocalization",
                     "SaveFeatures"]:
            self.addNode(node)
        self.reshape()
        self.connect("node_AudioStreamFromMic_1","AUDIO",
                     "node_MultiFFT_1","INPUT")
        self.connect("node_MultiFFT_1","OUTPUT",
                     "node_MatrixToMap_1","INPUT")
        self.connect("node_MatrixToMap_1","OUTPUT",
                     "node_PowerCalcForMap_1","INPUT")
        self.connect("node_MatrixToMap_1","OUTPUT",
                     "node_MSLSExtraction_1","SPECTRUM")
        self.connect("node_PowerCalcForMap_1","OUTPUT",
                     "node_MelFilterBank_1","INPUT")
        self.connect("node_MelFilterBank_1","OUTPUT",
                     "node_MSLSExtraction_1","FBANK")
        self.connect("node_MSLSExtraction_1","OUTPUT",
                     "node_FeatureRemover_1","INPUT")
        self.connect("node_FeatureRemover_1","OUTPUT",
                     "node_SaveFeatures_1","FEATURES")
        self.connect("node_ConstantLocalization_1","SOURCES",
                     "node_SaveFeatures_1","SOURCES")

        #self.addTerminalRole("node_AudioStreamFromWave_1","INPUT","Input","");
        #self.addTerminalRole("node_AudioStreamFromWave_1","NOT_EOF", 
        #                     "Condition", "")
        self.addTerminalRole("node_SaveFeatures_1", "OUTPUT", "Output", "")

        self.reshape()
        # build main
        self.screenshot("png", "demo-FeatureExtraction3-", True)

if __name__ == "__main__":
    unittest.main()
